
{$APPTYPE GUI}{$MODE DELPHI}

program demo2;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GraphOGL_Ext1;

//const
 
//type
  
//var 
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Scena;
begin
  // cielo
  SetVolumeFogAxis(0,0,-1);  // imposta l'asse  l'orientamento della nebbia 
  PushVolumeFog;             // modifica le coordinate per annullare la traslazione di glTranslatef()   
  TextureTGASelectID(0);  
  //SkyBox(0,7,0, 10);
  glPushMatrix;   
  glTranslatef(0,7,0);
  glScalef(1,1.25,1);   
  ResetVolumeFog;            // disattiva la modifica per glTranslatef() all'interno di SkyTube()
  SkyTube(0,0,0, 86, 32,1);
  glPopMatrix;   
  PopVolumeFog;              // resetta le coordinate
  SetVolumeFogAxis(0,1,0);   
  
  // elementi della scena
  glPushMatrix;  
  glTranslatef(-12,-12,-12);   
  glScalef(4.9,4.9,4.9); 
  
  // terreno
  TextureSelectID(0);  
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10);  
  
  // piramide
  PushVolumeFog;
  TextureSelectID(1);    
  Cubo2(0,0,0, -3,0,-3, 3,0.5,3, 0.5);
  Cubo2(0,0.5,0, -2.5,0,-2.5, 2.5,0.5,2.5, 0.5);  
  Cubo2(0,0.5*2,0, -2,0,-2, 2,0.5,2, 0.5);  
  Cubo2(0,0.5*3,0, -1.5,0,-1.5, 1.5,0.5,1.5, 0.5); 
  Cubo2(0,0.5*4,0, -1,0,-1, 1,0.5,1, 0.5); 
  Cubo2(0,0.5*5,0, -0.5,0,-0.5, 0.5,0.5,0.5, 0.5);     
  PopVolumeFog;
  
  // pilastri  
  Cubo2(-6,0,-2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);	 
  Cubo2(-6,0,0, -0.25,0,-0.25, 0.25,3,0.25, 0.5);
  Cubo2(-6,0,2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);  
 
  // muro
  Cubo2(0,0,-5, -6.5,0,-0.25, 3,1.6,0.25, 0.5);
  
  // torre
  PushVolumeFog;
  TextureSelectID(2);   
  Cubo2(6,0,0, -0.7,0,-0.7, 0.7,4.5,0.7, 0.5);   
  Cubo2(6,4.5,0, -1,0,-1, 1,0.5,1, 0.5);
  Cubo2(6-0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6-0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);
  Cubo2(6+0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6+0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);   
  Cubo2(6-0.9+0.6,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  PopVolumeFog;
 
  // scultura 
  PushVolumeFog;
  TextureSelectID(3);  
  glPushMatrix;
  glTranslatef(0,2.6,7.5);   
  glRotatef(90,0,1,0);
  ResetVolumeFog;  
  //PutglTeapot(0,0,0, 1,32);
  Ingranaggio(0,0,0, 2.5/1.25,3/1.25, 0.3/1.25, 32, 0.3/1.25,0.5,true,true,false,true,0.3,1,0.6,6);  
  glPopMatrix; 
  PopVolumeFog;
  
  glPopMatrix;   
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  SetQualityTexture2(GL_LINEAR,GL_LINEAR_MIPMAP_LINEAR);   
  TextureLoadTGAID('sky_rocksday6.tga',0); 
  
  SetQualityTexture2(GL_LINEAR,GL_LINEAR);  
  TextureLoadID('Floor04.bmp',0);
  TextureLoadID('rock.bmp',1);
  TextureLoadID('stoneblocks.bmp',2);  
  TextureLoadID('marmorizato.bmp',3); 
  
end;
begin 

  OpenGL_Texture();
  
  SetVolumeFog(GL_EXP2,1,1,1,0.5, 13,3);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(150,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-55);        // regola l'inquadratura degli elementi nello schermo 
  glRotatef(25,1,0,0); 
  SetglMouseMove(GL_M0,2);   
  glRotatef(45,0,-1,0);     
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);  
  
  SetglFogON; 
  AutoVolumeFogON; // abilita la generazione automatica delle coordinate della debbia
  
  Scena;
  
  AutoVolumeFogOFF;
  SetglFogOFF; 
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di generazione automatica della nebbia volumetrica', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(150,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
